import numpy as np
from mfb import moveFillBytesToFront

numchars=26
dw=7 #definition width
dh=16 #definition height


def dump_array_to_asm(file,name,data, stride=32):
    print(name, file=file)
    d=np.array(data).flat
    for i in range(0,len(d),stride):
        print("\t.byt "+",".join(["$%02x"%(x,) for x in d[i:i+stride]]), file=file)
    print(file=file)

def load():
    gy=[ 4*0, 4*1-1, 4*2-1, 4*3-1, 4*4-2, ]
    src=open("defs.txt")
    defs=[]
    sdh=5 #source definition height
    for i in range(numchars):
        src.readline()
        qr=[(src.readline()[:-1]+'    ')[:dw] for _ in range(sdh)]
        q=[' '*dw,]*dh
        for i in range(sdh):
            q[gy[i]]=qr[i]
        qi=[ [int(c!=' ') for c in r] for r in q]

        qi=np.reshape(qi,(-1,))

        defs.append(qi)
    defs=np.array(defs)
    return defs


defs=load()
counts=np.add.reduce(defs,axis=0)
used=np.zeros((2,dh*dw),np.int)

defg=np.zeros(len(defs),np.int)
for i in range(numchars):
    cu=np.compress(defs[i],counts)
    count_of_rarest=np.minimum.reduce(cu)
    defg[i]=(count_of_rarest<8)

for i in range(numchars):
    q=defs[i]
    gi=defg[i]
    for j in range(dw*dh):
        if q[j]==1:
            used[gi,j]=1

p0=set(np.argwhere(used[0]).flat)
p1=set(np.argwhere(used[1]).flat)
common=p0&p1

a=list(p0-common)
b=list(common)
c=list(p1-common)
a.sort()
b.sort()
c.sort()
ab=a+b



print("ll:")
print("{:2}".format(len(a)), a)
print("{:2}".format(len(b)), b)
print("{:2}".format(len(c)), c)
print()

defs=defs.reshape(-1,dh,dw)
defs=np.pad(defs, ((0,0),(0,0),(0,12-dw)), 'constant')
defs=defs.reshape(-1,dh*12)
ab=[12*(v//dw)+v%dw for v in ab]
c =[12*(v//dw)+v%dw for v in c ]



ab,plot_offset,patternbytes=moveFillBytesToFront(ab)





plt=[ab, ab+c]

bits=[]
for gi in range(2):
    for i in range(numchars):
        if defg[i]==gi:
            cat=defs[i][plt[gi]]
            bits.extend(list(cat)[::-1])







bits=[0,]+list(np.array(bits).reshape((-1)))
while len(bits)%8!=0:
    bits.append(0)
bits=np.array(bits)
bits=bits.reshape((-1,8))
data=bits@[128,64,32,16, 8,4,2,1]
data[0]=data[0]*2+1  # first byte only contains 7 bits and a sentinel, as it doubles as bitbuffer

print("char data length = ",len(data))
fo=open("font.gen","w")


dump_array_to_asm(fo,"grid_selector:", numchars-sum(defg))  # number of characters in group zero
print("grid0_count = {}".format(len(plt[0])), file=fo)
print("grid1_count = {}".format(len(plt[1])), file=fo)



ab=[(x+plot_offset)%256 for x in ab]
c =[(x+plot_offset)%256 for x in c ]


dump_array_to_asm(fo, "fillsource:", np.array(patternbytes)*2)
dump_array_to_asm(fo, "plt0:", ab)
dump_array_to_asm(fo, "plt_rest:", c)

print(file=fo)
print("bitbuffer:", file=fo)
dump_array_to_asm(fo, "charflags:", data)
print("charcount: .byt $c0 ;  Not using this anymore either. Another wasted byte!", file=fo)

fo=open("plotofse.gen","w")
print("plot_offset = ", plot_offset, file=fo)
